
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C的联合体和结构体区别 / 憋错料</title>

    <meta name="description" content="C的联合体和结构体区别 联合体与结构体是很容易混淆的概念.粗略一看,两者无论声明.定义还是定义对象的方式都很相似.然而这两个东西的概念和作用实际千差万别.首先,联合体的各个成员共用内存,并应该同时只能有一个成员得到这块内存的使用权(即对内存的读写),而结构体各个成员各自拥有内存,各自使用互不干涉.所以,某种意义上来说,联合体比结构体节约内存.举个例子:typedef struct{ int i; int j;}A;typedef union{ int i; double j;}U;sizeof(A)的值是8,sizeo">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C的联合体和结构体区别</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<pre>联合体与结构体是很容易混淆的概念。粗略一看，两者无论声明、定义还是定义对象的方式都很相似。然而这两个东西的概念和作用实际千差万别。首先，联合体的各个成员共用内存，并应该同时只能有一个成员得到这块内存的使用权（即对内存的读写），而结构体各个成员各自拥有内存，各自使用互不干涉。所以，某种意义上来说，联合体比结构体节约内存。举个例子：typedef struct{    int i;    int j;}A;typedef union{  int i;  double j;}U;sizeof(A)的值是8，sizeof(U)的值也是8（不是12）。为什么sizeof(U)不是12呢？因为union中各成员共用内存，i和j的内存是同一块。而且整体内存大小以最大内存的成员的划分。即U的内存大小是double的大小，为8了。sizeof(A)大小为8，因为struct中i和j各自得到了一块内存，每人4个字节，加起来就是8了。了解了联合体共用内存的概念，也就是明白了为何每次只能对其一个成员赋值了，因为如果对另一个赋值，会覆盖了上一个成员的值。</pre>
<hr />
<pre><strong>是的，函数的重载是在编译的时候发生，而虚函数是在运行的时候确定。其实有时候称函数的重载为静态多态性，而虚函数为动态多态性</strong></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 23:11:23 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C的联合体和结构体区别的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dodArM.html" rel="bookmark">联合体与结构体的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				联合体,又称共用体.编程的时候需要使几种不同类型的变量存放到同一段内存单元中,而衍生出来的一种类型.也就是说,联合体中每次只能存其中的一个变量,这个变量在联合体变量中存入新的成员就失效了!!!用法与结构体一致,但是多用于结构体内部. 1 struct name 2 { 3 int age; 4 char* name; 5 union text //text是标题,标题可以不写 ,此标题在在结构体内无作用 6 { 7 char a; 8 ... 9 } 10 }mytext;//mytext是结构			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ko7Az0.html" rel="bookmark">联合体和结构体</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文编辑整理自: http://bbs.chinaunix.net/forum.php?mod=viewthread&amp;tid=179471 一.前言 &quot;联合体&quot;(union)与&quot;结构体&quot;(struct)有一些相似之处.但两者有本质上的不同.在结构体中,各成员有各自的内存空间, 一个结构变量的总长度是各成员长度之和.而在&quot;联合&quot;中,各成员共享一段内存空间, 一个联合变量的长度等于各成员中最长的长度.应该说明的是, 这里所谓的共享不是指把多个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLZ95Q3.html" rel="bookmark">C语言-结构体-联合体</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				结构体 在Java中,我们要表示一个复合的数据类型就会使用对象去封装.而C就有结构体. 结构体是C语言中自定义的数据类型,是一组变量的集合,有别于数组,数组仅限于同一种数据类型,而结构体可以是任何数据类型,包括数组.结构体里面的每一个变量或者数组都是结构体的成员. 下面来看看结构体的基本使用 14-18行,定义了一个名称为Person的结构体,结构体里面有 age,money,sex 三种数据类型: 20-24行,是结构体的声明一个名为 P 的 Person 变量,并赋值: 25-27行,是结构			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/k0njwj0.html" rel="bookmark">结构体&sol;联合体 所占用内存</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 #include &quot;stdafx.h&quot; 2 #include &lt;iostream&gt; 3 using namespace std; 4 5 typedef struct Parameter{ 6 int a; 7 long b; 8 double c; 9 int d; 10 }Parameter; 11 12 typedef union Para{ 13 unsigned a; 14 double b; 15 long c; 16 int d; 17 }Para; 18			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmDAWV4.html" rel="bookmark">第五章：数组 结构体 和联合体</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.结构体 2.联合体 3.结构体和联合体的操作 4.非压缩数组 5.压缩数组 6.数组操作 7.数组foreache 循环 8.用于数组的特殊系统函数 结构体 1.结构体成员可以是任何数据类型 包括基本类型和用户自定义类型 2.结构体的声明 var/wire 都可以定义为结构体类型.当定义为结构体类型时,结构体中的成员都必须是四态类型,成员不能是wire类型. 3.结构体的初始化 用值列表方式初始化 '{} 4.结构体的赋值 5.压缩结构体 可以视为独立的变量,具体与向量类似的操作 6.非压缩			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzrnR2M.html" rel="bookmark">类的声明 ， 类和结构体的区别 ， 内联函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#include&lt;iostream&gt; using namespace std; class A;//类的声明 class B { private: A *a;//必须是指针 ,不能为 A a; }; class  A { private: B b; }; int main() {} 类和结构体区别: 结构体默认public 类默认是private 在继承方式:结构体默认公有继承 类默认私有继承 inline 调用内联函数并没有执行函数的调用过程,只是把函数的代码嵌入到了程序的调用点 , 减少了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38KLOn0.html" rel="bookmark">swift 类和结构体</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1:类和结构体定义 类和结构体分别通过关键字class 和struct定义. swift的编码风格是类class和结构体struct名字使用大写字母开头的匈牙利表示法,相反的.类的方法和属性则用小写字母开头的匈牙利表示法. 结构体总是通过被复制而进行代码传递的. struct SForm{ var iXX:Int = 99 var strHello:String = &quot;dsf&quot; func testFunc(iXX:Int)-&gt;Int{ return iXX+1 } } class			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4975Kv0.html" rel="bookmark">结构体与联合体的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				联合体用途:使几个不同类型的变量共占一段内存(相互覆盖) 结构体是一种构造数据类型用途:把不同类型的数据组合成一个整体-------自定义数据类型 Struct与Union主要有以下区别: 1. struct和union都是由多个不同的数据类型成员组成, 但在任何同一时刻, union中只存放了一个被选中的成员, 而struct的所有成员都存在.在struct中,各成员都占有自己的内存空间,它们是同时存在的.一个struct变量的总长度等于所有成员长度之和.在Union中,所有成员不能同时占用它			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JkDL9M.html" rel="bookmark">数组、结构体、联合体、枚举类型、类型转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.数组 int num[2] = { 1, 2 };//1×2,num[0]=1 int num[2][2] = { { 00, 01 }, { 10, 11 } };//2×2,num[1][1]=11 int num[2][2][2] = { {{000,001},{010,011}}, {{100,101},{110,111}} };//2个2×2数组,num[1][1][1]=111 2.结构体 #include &lt;stdio.h&gt; int main() { struct Famil			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q3qYbz3.html" rel="bookmark" class="title">东北育才 DAY2组合数取mod &lpar;comb&rpar;</a>
					<div>
						组合数取模(comb) [问题描述] 计算C(m,n)mod 9901的值 [输入格式] 从文件comb.in中输入数据. 输入的第一行包含两个整数,m和n [输出格式] 输出到文件comb.out中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWyYWa3.html" rel="bookmark" class="title">每多学一点知识，就少写一行代码</a>
					<div>
						这一个月看书不少,买了4本,已经看完了2本,剩下的2本计划2周内看完,2周内看完也太慢了,还有不少书等着我看, 以后相当长一段时期内,给自己看书的要求是必须2周内看完一本书,每月2本书,每年24本书. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38N1zKM.html" rel="bookmark" class="title">DSP-BIOS使用入门</a>
					<div>
						从环境说到搭建第一个工程 请注意,此文默认读者已经对DSP及CCS V3.3环境有一定的了解了,知道cmd文件的配置,知道新建工程,编译并连接仿真器下载!如果你对这些还都不熟悉,请先熟悉这些!当然,最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dxpy90.html" rel="bookmark" class="title">转&colon; requestAnimationFrame，Web中写动画的另一种选择</a>
					<div>
						HTML5/CSS3时代,我们要在web里做动画选择其实已经很多了: 你可以用CSS3的animattion+keyframes; 你也可以用css3的transition; 你还可以用通过在canv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmDRaB4.html" rel="bookmark" class="title">linux 下搭建zabbix 监控</a>
					<div>
						一.什么是zabbix 1.zabbix的简介 zabbix是一个基于WEB界面的提供分布式系统监视以及网络监视功能的企业级的开源解决方案. 能监视各种网络参数,保证服务器系统的安全运营;并提供柔软的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEQJ90.html" rel="bookmark" class="title">关于格子之如何判断对方喜欢你</a>
					<div>
						飞碟说78:&lt;如何判断对方是否喜欢你&gt;优酷视频在线观看.人生有三大错觉:手机震动,有人敲门,他/她喜欢我.自作多情简直是人生常态!如何从蛛丝马迹中分辨动情信号? 视频开头开场的背景音乐:D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nvpoV0.html" rel="bookmark" class="title">iOS开源项目大全</a>
					<div>
						UI界面类项目: Panoramagl —— 720全景展示 Panorama viewer library for iPhone, iPad and iPod touch MBProgressHUD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pz9880.html" rel="bookmark" class="title">数据库专攻总结 完结（第三天）</a>
					<div>
						create table student( id int(3) auto_incrememt primary key not null, name varchar(10) default null,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y79yw4.html" rel="bookmark" class="title">DocCms存储型XSS&plus;后台任意文件下载上传&plus;目录删除&plus;sql执行&lpar;有条件可getshell&rpar;</a>
					<div>
						下载链接 https://share.weiyun.com/46ebceb4fe91da144ad2661522a941e1 留言处存储型XSS 漏洞在content/guestbook/index. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35AJOn3.html" rel="bookmark" class="title">数据库中三种范式的讲解</a>
					<div>
						数据库三大范式详解 设计关系数据库时,遵从不同的规范要求,设计出合理的关系型数据库,这些不同的规范要求被称为不同的范式,各种范式呈递次规范,越高的范式数据库冗余越小. 目前关系数据库有六种范式:第一范 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41ox1o0.html" rel="bookmark" class="title">JavaScript简易日历</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//h2D XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmoBgY3.html" rel="bookmark" class="title">MVC - 13&period;验证</a>
					<div>
						1.MVC验证 1.1.验证方式 引入命名空间 using System.ComponentModel.DataAnnotations; 定义验证规则: Model属性添加内置验证特性,介绍用的最多的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49Lo9v3.html" rel="bookmark" class="title">Struts2 resulttype</a>
					<div>
						本文章只介绍较为常用的三种result type 1.dispatcher 2.redirect 3.redirectAction 一.dispatcher 用于转向JSP页面,这个是默认的结果类型, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/471yjD0.html" rel="bookmark" class="title">有待整理</a>
					<div>
						/** 002 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved. 003 * 004 * This library is fre ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnDm80.html" rel="bookmark" class="title">用JS写的百叶窗</a>
					<div>
						&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;meta charset=&quot;utf-8&quot;&gt;&lt;title&gt;无标题文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RnmAp0.html" rel="bookmark" class="title">Awrload导入数据报ORA-20104、ORA-06512错误处理</a>
					<div>
						1.Awrload导入数据报ORA-20104.ORA-06512错误 SQL&gt; @?/rdbms/admin/awrload.sql ~~~~~~~~~~ AWR LOAD ~~~~~~~~~ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y1Zmy0.html" rel="bookmark" class="title">EXCLE中快速插入图片</a>
					<div>
						在excle中怎么快速插入图片呢,一张一张点实在比较麻烦 解决办法: &lt;table&gt;&lt;img src=&quot;D:\A.png&quot; width=&quot;60&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXZaDk3.html" rel="bookmark" class="title">Python中的&lowbar;&lowbar;new&lowbar;&lowbar;及其用法</a>
					<div>
						__new__和__init__的区别 __new__是Python面向对象语言中一个很少用的函数,更多使用的是__init__这个函数.例如: class Book(object):     def ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38yYK14.html" rel="bookmark" class="title">每个工程师都应该了解的：聊聊幂等</a>
					<div>
						转载至:http://mp.weixin.qq.com/s/EDkuMW5-hdIxs2GXMFnj_Q 什么是幂等(Idempotency)?简单来说,一个操作如果具有任意多次执行所产生的影响均与一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6XdNZ3.html" rel="bookmark" class="title">py流程控制</a>
					<div>
						一.条件判断 if ..else &gt;&gt;&gt; user='yaobin' &gt;&gt;&gt; passwd='yaobin123' &gt;&gt;&gt; user_input= ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
